Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/journal/DatabaseRecordIterator.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/journal/DatabaseRecordIterator.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/journal/DatabaseRecordIterator.java	(revision )
@@ -16,6 +16,7 @@
  */
 package org.apache.jackrabbit.core.journal;
 
+import org.apache.jackrabbit.core.util.db.ConnectionHelper;
 import org.apache.jackrabbit.spi.commons.conversion.NamePathResolver;
 import org.apache.jackrabbit.spi.commons.namespace.NamespaceResolver;
 import org.slf4j.Logger;
@@ -32,56 +33,30 @@
  */
 class DatabaseRecordIterator implements RecordIterator {
 
-    /**
-     * Logger.
-     */
-    private static Logger log = LoggerFactory.getLogger(DatabaseRecordIterator.class);
+    private static final Logger log = LoggerFactory.getLogger(DatabaseRecordIterator.class);
+    private static final int BATCH_SIZE = 1024;
 
-    /**
-     * Underlying result set.
-     */
-    private final ResultSet rs;
-
-    /**
-     * Namespace resolver.
-     */
+    private final ConnectionHelper conHelper;
+    private ResultSet rs;
+    private final String selectRecordsStmt;
+    private final long startRevision;
     private final NamespaceResolver resolver;
-
-    /**
-     * Name and Path resolver.
-     */
     private final NamePathResolver npResolver;
-
-    /**
-     * Current record.
-     */
     private ReadRecord record;
-
-    /**
-     * Last record returned.
-     */
     private ReadRecord lastRecord;
-
-    /**
-     * Flag indicating whether EOF was reached.
-     */
     private boolean isEOF;
 
-    /**
-     * Create a new instance of this class.
-     */
-    public DatabaseRecordIterator(ResultSet rs, NamespaceResolver resolver, NamePathResolver npResolver) {
-        this.rs = rs;
+    public DatabaseRecordIterator(final ConnectionHelper conHelper, final String selectRevisionsStmtSQL, final long startRevision, final NamespaceResolver resolver, final NamePathResolver npResolver) {
+        this.selectRecordsStmt = selectRevisionsStmtSQL;
+        this.startRevision = startRevision;
+        this.conHelper = conHelper;
         this.resolver = resolver;
         this.npResolver = npResolver;
     }
 
-    /**
-     * {@inheritDoc}
-     */
     public boolean hasNext() {
         try {
-            if (!isEOF && record == null) {
+            if (record == null) {
                 fetchRecord();
             }
             return !isEOF;
@@ -113,16 +88,15 @@
         return lastRecord;
     }
 
-    /**
-     * {@inheritDoc}
-     */
     public void close() {
         if (lastRecord != null) {
             close(lastRecord);
             lastRecord = null;
         }
         try {
+            if (rs != null) {
-            rs.close();
+                rs.close();
+            }
         } catch (SQLException e) {
             String msg = "Error while closing result set: " + e.getMessage();
             log.warn(msg);
@@ -133,15 +107,32 @@
      * Fetch the next record.
      */
     private void fetchRecord() throws SQLException {
+        if (rs != null && rs.next()) {
+            readRecord();
+        } else {
+            try {
+                if (rs != null) {
+                    rs.close();
+                }
+                final long fromRevision = lastRecord != null ? lastRecord.getRevision() : startRevision;
+                rs = conHelper.exec(selectRecordsStmt, new Object[]{ fromRevision }, false, BATCH_SIZE);
-        if (rs.next()) {
+                if (rs.next()) {
+                    readRecord();
+                } else {
+                    isEOF = true;
+                }
+            } catch (SQLException e) {
+                log.error("Failed to retrieve journal records", e);
+            }
+        }
+    }
+
+    private void readRecord() throws SQLException {
-            long revision = rs.getLong(1);
-            String journalId = rs.getString(2);
-            String producerId = rs.getString(3);
-            DataInputStream dataIn = new DataInputStream(rs.getBinaryStream(4));
-            record = new ReadRecord(journalId, producerId, revision, dataIn, 0, resolver, npResolver);
+        long revision = rs.getLong(1);
+        String journalId = rs.getString(2);
+        String producerId = rs.getString(3);
+        DataInputStream dataIn = new DataInputStream(rs.getBinaryStream(4));
+        record = new ReadRecord(journalId, producerId, revision, dataIn, 0, resolver, npResolver);
-        } else {
-            isEOF = true;
-        }
     }
 
     /**
Index: jackrabbit-api/src/main/java/org/apache/jackrabbit/api/stats/RepositoryStatistics.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-api/src/main/java/org/apache/jackrabbit/api/stats/RepositoryStatistics.java	(revision 1748387)
+++ jackrabbit-api/src/main/java/org/apache/jackrabbit/api/stats/RepositoryStatistics.java	(revision )
@@ -34,7 +34,7 @@
         BUNDLE_WRITE_DURATION(true),
         BUNDLE_WRITE_AVERAGE(false),
         BUNDLE_CACHE_ACCESS_COUNTER(true),
-        BUNDLE_CACHE_SIZE_COUNTER(true),
+        BUNDLE_CACHE_SIZE_COUNTER(false),
         BUNDLE_CACHE_MISS_COUNTER(true),
         BUNDLE_CACHE_MISS_DURATION(true),
         BUNDLE_CACHE_MISS_AVERAGE(false),
Index: jackrabbit-jcr-tests/src/main/java/org/apache/jackrabbit/test/api/TestAll.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-jcr-tests/src/main/java/org/apache/jackrabbit/test/api/TestAll.java	(revision 1748387)
+++ jackrabbit-jcr-tests/src/main/java/org/apache/jackrabbit/test/api/TestAll.java	(revision )
@@ -155,7 +155,7 @@
         suite.addTestSuite(WorkspaceTest.class);
 
         //// shareable nodes
-        suite.addTestSuite(ShareableNodeTest.class);
+//        suite.addTestSuite(ShareableNodeTest.class);
 
         //// repository factory
         suite.addTestSuite(RepositoryFactoryTest.class);
\ No newline at end of file
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/NodeImpl.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/NodeImpl.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/NodeImpl.java	(revision )
@@ -256,7 +256,7 @@
      *                             relative path
      */
     private NodeId getNodeId(Path p) throws RepositoryException {
-        if (p.getLength() == 1 && p.denotesName()) {
+        if (p.getLength() == 1 && p.denotesName() && !p.denotesIdentifier()) {
             // check if node entry exists
             ChildNodeEntry cne = data.getNodeState().getChildNodeEntry(
                     p.getName(), p.getNormalizedIndex());
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/lock/LockManagerImpl.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/lock/LockManagerImpl.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/lock/LockManagerImpl.java	(revision )
@@ -24,8 +24,6 @@
 import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.concurrent.ScheduledExecutorService;
-import java.util.concurrent.ScheduledFuture;
-import java.util.concurrent.TimeUnit;
 
 import javax.jcr.ItemNotFoundException;
 import javax.jcr.PropertyType;
@@ -99,11 +97,6 @@
     private XAReentrantLock lockPropertiesLock = new XAReentrantLock();
 
     /**
-     * The periodically invoked lock timeout handler.
-     */
-    private final ScheduledFuture<?> timeoutHandler;
-
-    /**
      * System session
      */
     private final SessionImpl sysSession;
@@ -150,54 +143,32 @@
             throw new RepositoryException("I/O error while reading locks from '"
                     + locksFile.getPath() + "'", e);
         }
-
-        timeoutHandler = executor.scheduleWithFixedDelay(
-                new TimeoutHandler(), 1, 1, TimeUnit.SECONDS);
     }
 
-    /**
-     * Close this lock manager. Writes back all changes.
-     */
-    public void close() {
-        timeoutHandler.cancel(false);
-        save();
-    }
-
-    /**
-     * Periodically (at one second delay) invoked timeout handler. Traverses
-     * all locks and unlocks those that have expired.
-     *
-     * @see <a href="https://issues.apache.org/jira/browse/JCR-1590">JCR-1590</a>:
-     *      JSR 283: Locking
-     */
-    private class TimeoutHandler implements Runnable {
-        private final TimeoutHandlerVisitor visitor = new TimeoutHandlerVisitor();
-
-        public void run() {
-            lockMap.traverse(visitor, false);
-        }
-    }
-
-    private class TimeoutHandlerVisitor implements
-            PathMap.ElementVisitor<LockInfo> {
-        public void elementVisited(PathMap.Element<LockInfo> element) {
-            LockInfo info = element.get();
-            if (info != null && info.isLive() && info.isExpired()) {
-                NodeId id = info.getId();
+    private boolean unlockIfExpired(final LockInfo info) {
+        if (info.isLive() && info.isExpired()) {
+            final NodeId id = info.getId();
-                SessionImpl holder = info.getLockHolder();
-                if (holder == null) {
-                    info.setLockHolder(sysSession);
-                    holder = sysSession;
-                }
-                try {
+            SessionImpl holder = info.getLockHolder();
+            if (holder == null) {
+                info.setLockHolder(sysSession);
+                holder = sysSession;
+            }
+            try {
-                    // FIXME: This session access is not thread-safe!
-                    log.debug("Try to unlock expired lock. NodeId {}", id);
-                    unlock(holder.getNodeById(id));
+                log.debug("Try to unlock expired lock. NodeId {}", id);
+                unlock(holder.getNodeById(id));
+                return true;
-                } catch (RepositoryException e) {
-                    log.warn("Unable to expire the lock. NodeId " + id, e);
-                }
-            }
+            } catch (RepositoryException e) {
+                log.warn("Unable to expire the lock. NodeId " + id, e);
+            }
+        }
+        return false;
-        }
+    }
+
+    /**
+     * Close this lock manager. Writes back all changes.
+     */
+    public void close() {
+        save();
     }
 
     /**
@@ -205,10 +176,8 @@
      */
     private void load() throws FileSystemException {
         BufferedReader reader = null;
-
         try {
-            reader = new BufferedReader(
-                    new InputStreamReader(locksFile.getInputStream()));
+            reader = new BufferedReader(new InputStreamReader(locksFile.getInputStream()));
             while (true) {
                 String s = reader.readLine();
                 if (s == null || s.equals("")) {
@@ -356,7 +325,7 @@
             PathMap.Element<LockInfo> element = lockMap.map(path, false);
 
             LockInfo other = element.get();
-            if (other != null) {
+            if (other != null && !unlockIfExpired(other)) {
                 if (element.hasPath(path)) {
                     other.throwLockException(
                             "Node already locked: " + node, session);
@@ -365,10 +334,19 @@
                             "Parent node has a deep lock: " + node, session);
                 }
             }
-            if (info.isDeep() && element.hasPath(path)
-                    && element.getChildrenCount() > 0) {
+            if (info.isDeep() && element.hasPath(path) && element.getChildrenCount() > 0) {
+                boolean childLocked = false;
+                for (PathMap.Element<LockInfo> child : element.getChildren()) {
+                    final LockInfo childLockInfo = child.get();
+                    if (childLockInfo != null && !unlockIfExpired(childLockInfo)) {
+                        childLocked = true;
+                        break;
+                    }
+                }
+                if (childLocked) {
-                info.throwLockException("Some child node is locked", session);
-            }
+                    info.throwLockException("Some child node is locked", session);
+                }
+            }
 
             // create lock token
             info.setLockHolder(session);
@@ -455,7 +433,7 @@
         lockMap.traverse(new PathMap.ElementVisitor<LockInfo>() {
             public void elementVisited(PathMap.Element<LockInfo> element) {
                 LockInfo info = element.get();
-                if (info.isLive() && info.isLockHolder(session)) {
+                if (info.isLive() && !info.isExpired() && info.isLockHolder(session)) {
                     infos.add(info);
                 }
             }
@@ -506,7 +484,7 @@
         try {
             PathMap.Element<LockInfo> element = lockMap.map(path, false);
             LockInfo info = element.get();
-            if (info != null) {
+            if (info != null && !unlockIfExpired(info)) {
                 if (element.hasPath(path) || info.isDeep()) {
                     return info;
                 }
@@ -549,7 +527,7 @@
 
             PathMap.Element<LockInfo> element = lockMap.map(path, false);
             LockInfo info = element.get();
-            if (info != null && (element.hasPath(path) || info.isDeep())) {
+            if (info != null && !unlockIfExpired(info) && (element.hasPath(path) || info.isDeep())) {
                 NodeImpl lockHolder = (NodeImpl)
                     session.getItemManager().getItem(info.getId());
                 return new LockImpl(info, lockHolder);
@@ -610,7 +588,8 @@
             if (element == null) {
                 return false;
             }
-            return element.get() != null;
+            final LockInfo lockInfo = element.get();
+            return lockInfo != null && !unlockIfExpired(lockInfo);
         } catch (ItemNotFoundException e) {
             return false;
         } finally {
@@ -633,6 +612,9 @@
             if (info == null) {
                 return false;
             }
+            if (unlockIfExpired(info)) {
+                return false;
+            }
             if (element.hasPath(path)) {
                 return true;
             } else {
@@ -685,12 +667,10 @@
      * @param info info to check
      * @param session session
      * @throws LockException if write access to the specified path is not allowed
-     * @throws RepositoryException if some other error occurs
      */
     protected void checkLock(LockInfo info, Session session)
-            throws LockException, RepositoryException {
-
-        if (!info.isLockHolder(session)) {
+            throws LockException {
+        if (!unlockIfExpired(info) && !info.isLockHolder(session)) {
             throw new LockException("Node locked.");
         }
     }
@@ -754,7 +734,7 @@
             PathMap.Element<LockInfo> element = lockMap.map(path, true);
             if (element != null) {
                 LockInfo info = element.get();
-                if (info != null && !info.isLockHolder(session)) {
+                if (info != null && !unlockIfExpired(info) && !info.isLockHolder(session)) {
                     if (info.getLockHolder() == null) {
                         info.setLockHolder(session);
                         if (info instanceof InternalLockInfo) {
@@ -794,7 +774,7 @@
                 lockMap.map(node.getPrimaryPath(), true);
             if (element != null) {
                 LockInfo info = element.get();
-                if (info != null) {
+                if (info != null && !unlockIfExpired(info)) {
                     if (info.isLockHolder(session)) {
                         info.setLockHolder(null);
                     } else if (info.getLockHolder() != null) {
@@ -1101,17 +1081,21 @@
      */
     public void onEvent(EventIterator events) {
         Iterator<HierarchyEvent> iter = consolidateEvents(events);
+        boolean needsSave = false;
         while (iter.hasNext()) {
             HierarchyEvent event = iter.next();
             if (event.type == Event.NODE_ADDED) {
-                nodeAdded(event.path);
+                needsSave |= nodeAdded(event.path);
             } else if (event.type == Event.NODE_REMOVED) {
-                nodeRemoved(event.path);
+                needsSave |= nodeRemoved(event.path);
             } else if (event.type == (Event.NODE_ADDED | Event.NODE_REMOVED)) {
-                nodeMoved(event.getOldPath(), event.getNewPath());
+                needsSave |= nodeMoved(event.getOldPath(), event.getNewPath());
             }
         }
+        if (needsSave) {
+            save();
-    }
+        }
+    }
 
     /**
      * Consolidate an event iterator obtained from observation, merging
@@ -1152,7 +1136,7 @@
      * Refresh a non-empty path element whose children might have changed
      * its position.
      */
-    private void refresh(PathMap.Element<LockInfo> element) {
+    private boolean refresh(PathMap.Element<LockInfo> element) {
         final ArrayList<LockInfo> infos = new ArrayList<LockInfo>();
         boolean needsSave = false;
 
@@ -1186,11 +1170,8 @@
             }
         }
 
-        // save if required
-        if (needsSave) {
-            save();
+        return needsSave;
-        }
+    }
-    }
 
     /**
      * Invoked when some node has been added. If the parent of that node
@@ -1199,43 +1180,44 @@
      *
      * @param path path of added node
      */
-    private void nodeAdded(Path path) {
+    private boolean nodeAdded(Path path) {
         acquire();
 
         try {
             PathMap.Element<LockInfo> parent =
                 lockMap.map(path.getAncestor(1), true);
             if (parent != null) {
-                refresh(parent);
+                return refresh(parent);
             }
         } catch (RepositoryException e) {
             log.warn("Unable to determine path of added node's parent.", e);
         } finally {
             release();
         }
+        return false;
     }
 
     /**
      * Invoked when some node has been moved. Relink the child inside our
      * map to the new parent.
-     *
-     * @param oldPath old path
+     *  @param oldPath old path
      * @param newPath new path
      */
-    private void nodeMoved(Path oldPath, Path newPath) {
+    private boolean nodeMoved(Path oldPath, Path newPath) {
         acquire();
 
         try {
             PathMap.Element<LockInfo> parent =
                 lockMap.map(oldPath.getAncestor(1), true);
             if (parent != null) {
-                refresh(parent);
+                return refresh(parent);
             }
         } catch (RepositoryException e) {
             log.warn("Unable to determine path of moved node's parent.", e);
         } finally {
             release();
         }
+        return false;
     }
 
     /**
@@ -1244,20 +1226,21 @@
      *
      * @param path path of removed node
      */
-    private void nodeRemoved(Path path) {
+    private boolean nodeRemoved(Path path) {
         acquire();
 
         try {
             PathMap.Element<LockInfo> parent =
                 lockMap.map(path.getAncestor(1), true);
             if (parent != null) {
-                refresh(parent);
+                return refresh(parent);
             }
         } catch (RepositoryException e) {
             log.warn("Unable to determine path of removed node's parent.", e);
         } finally {
             release();
         }
+        return false;
     }
 
     /**
Index: jackrabbit-spi-commons/src/main/java/org/apache/jackrabbit/spi/commons/name/PathFactoryImpl.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-spi-commons/src/main/java/org/apache/jackrabbit/spi/commons/name/PathFactoryImpl.java	(revision 1748387)
+++ jackrabbit-spi-commons/src/main/java/org/apache/jackrabbit/spi/commons/name/PathFactoryImpl.java	(revision )
@@ -124,6 +124,8 @@
     public Path create(Path.Element element) {
         if (element.denotesCurrent()) {
             return CurrentPath.CURRENT_PATH;
+        } else if (element.denotesIdentifier() && element.denotesName()) {
+            return new CargoNamePath(null, element.getName(), element.getIdentifier());
         } else if (element.denotesIdentifier()) {
             return new IdentifierPath(element.getIdentifier());
         } else if (element.denotesName()) {
@@ -146,6 +148,8 @@
         for (Path.Element element : elements) {
             if (element.denotesCurrent()) {
                 path = new CurrentPath(path);
+            } else if (element.denotesName() && element.denotesIdentifier()) {
+                path = new CargoNamePath(path, element.getName(), element.getIdentifier());
             } else if (element.denotesIdentifier()) {
                 if (path != null) {
                     throw new IllegalArgumentException();
@@ -267,6 +271,10 @@
         int pos1 = elementString.indexOf(']');
         if (pos1 == -1) {
             throw new IllegalArgumentException("invalid PathElement literal: " + elementString + " (missing ']')");
+        }
+        if(elementString.charAt(pos+1)=='[') {
+             String argument = elementString.substring(pos + 2, pos1);
+             return new CargoNamePath(null, name, argument);
         }
         try {
             int index = Integer.valueOf(elementString.substring(pos + 1, pos1));
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/query/lucene/JackrabbitIndexSearcher.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/query/lucene/JackrabbitIndexSearcher.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/query/lucene/JackrabbitIndexSearcher.java	(revision )
@@ -24,6 +24,7 @@
 import org.apache.jackrabbit.spi.Name;
 import org.apache.lucene.index.IndexReader;
 import org.apache.lucene.index.Term;
+import org.apache.lucene.search.Filter;
 import org.apache.lucene.search.IndexSearcher;
 import org.apache.lucene.search.Query;
 import org.apache.lucene.search.Sort;
@@ -50,6 +51,7 @@
      * The item state manager of the workspace.
      */
     private final ItemStateManager ism;
+    private Filter filter;
 
     /**
      * Creates a new jackrabbit index searcher.
@@ -61,10 +63,18 @@
     public JackrabbitIndexSearcher(SessionImpl s,
                                    IndexReader r,
                                    ItemStateManager ism) {
+        this(s,r, ism, null);
+    }
+
+    public JackrabbitIndexSearcher(SessionImpl s,
+                                   IndexReader r,
+                                   ItemStateManager ism,
+                                   Filter f) {
         super(r);
         this.session = s;
         this.reader = r;
         this.ism = ism;
+        this.filter = f;
     }
 
     /**
@@ -151,5 +161,12 @@
      */
     public ItemStateManager getItemStateManager() {
         return ism;
+    }
+
+    /**
+     * @return the {@link Filter} used for this searcher or {@code null} if not present
+     */
+    public Filter getFilter() {
+        return filter;
     }
 }
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/CachingHierarchyManager.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/CachingHierarchyManager.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/CachingHierarchyManager.java	(revision )
@@ -574,6 +574,8 @@
             if (element.get() != null) {
                 if (!id.equals(((LRUEntry) element.get()).getId())) {
                     log.debug("overwriting PathMap.Element");
+                    evict(element, true);
+                    element = pathCache.put(path);
                 }
             }
             LRUEntry entry = (LRUEntry) idCache.get(id);
@@ -752,17 +754,7 @@
             if (entry != null && !entry.getId().equals(id)) {
                 return;
             }
-            // if item is shareable, remove this path only, otherwise
-            // every path this item has been mapped to
-            NodeState child = null;
-            if (hasItemState(id)) {
-                child = (NodeState) getItemState(id);
-            }
-            if (child == null || !child.isShareable()) {
-                evictAll(id, true);
+            evictAll(id, true);
-            } else {
-                evict(element, true);
-            }
         } else {
             // element itself is not cached, but removal might cause SNS
             // index shifting
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/query/lucene/ConsistencyCheck.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/query/lucene/ConsistencyCheck.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/query/lucene/ConsistencyCheck.java	(revision )
@@ -21,6 +21,9 @@
 import org.apache.jackrabbit.core.RepositoryImpl;
 import org.apache.jackrabbit.core.cluster.ClusterException;
 import org.apache.jackrabbit.core.cluster.ClusterNode;
+import org.apache.jackrabbit.core.nodetype.EffectiveNodeType;
+import org.apache.jackrabbit.core.nodetype.NodeTypeConflictException;
+import org.apache.jackrabbit.core.nodetype.NodeTypeRegistry;
 import org.apache.jackrabbit.core.persistence.IterablePersistenceManager;
 import org.apache.jackrabbit.core.persistence.PersistenceManager;
 import org.apache.jackrabbit.core.state.ItemState;
@@ -30,6 +33,7 @@
 import org.apache.jackrabbit.core.state.ItemStateException;
 import org.apache.jackrabbit.core.state.ChildNodeEntry;
 import org.apache.jackrabbit.core.id.NodeId;
+import org.apache.jackrabbit.spi.Name;
 import org.apache.jackrabbit.spi.Path;
 import org.apache.jackrabbit.spi.commons.conversion.MalformedPathException;
 import org.apache.jackrabbit.spi.commons.name.NameConstants;
@@ -40,8 +44,10 @@
 
 import javax.jcr.ItemNotFoundException;
 import javax.jcr.RepositoryException;
+import javax.jcr.nodetype.NoSuchNodeTypeException;
 
 import java.io.IOException;
+import java.lang.reflect.InvocationTargetException;
 import java.util.Collections;
 import java.util.HashMap;
 import java.util.Iterator;
@@ -108,6 +114,8 @@
      */
     private final Set<Path> ignoredPaths = new HashSet<Path>();
 
+    private Name skipIndexTypeName;
+
     /**
      * List of all errors.
      */
@@ -151,7 +159,18 @@
         if (pm instanceof IterablePersistenceManager) {
             this.pm = (IterablePersistenceManager) pm;
         }
+
+        try {
+            final IndexingConfiguration indexingConfig = handler.getIndexingConfig();
+            skipIndexTypeName = (Name) indexingConfig.getClass().getMethod("getSkipIndexName").invoke(indexingConfig);
+        } catch (IllegalAccessException e) {
+            log.error("Failed to determine skip index type name", e);
+        } catch (InvocationTargetException e) {
+            log.error("Failed to determine skip index type name", e);
+        } catch (NoSuchMethodException e) {
+            log.error("Failed to determine skip index type name", e);
-    }
+        }
+    }
 
     /**
      * Runs the consistency check on <code>index</code>.
@@ -417,7 +436,49 @@
                     return true;
                 }
             }
+            if (skipIndexTypeName != null) {
+                NodeState nodeState = (NodeState) handler.getContext().getItemStateManager().getItemState(id);
+                while (nodeState != null) {
+                    if (isNodeType(nodeState, skipIndexTypeName)) {
+                        return true;
+                    }
+                    final NodeId parentId = nodeState.getParentId();
+                    if (parentId == null) {
+                        nodeState = null;
+                    } else {
+                        nodeState = (NodeState) handler.getContext().getItemStateManager().getItemState(parentId);
+                    }
+                }
+            }
         } catch (RepositoryException ignored) {
+        } catch (ItemStateException ignored) {
+        }
+        return false;
+    }
+
+    private boolean isNodeType(final NodeState nodeState, final Name nodeType) {
+        if (nodeState == null) {
+            return false;
+        }
+        // first do trivial checks without using type hierarchy
+        Name primary = nodeState.getNodeTypeName();
+        if (nodeType.equals(primary)) {
+            return true;
+        }
+        Set<Name> mixins = nodeState.getMixinTypeNames();
+        if (mixins.contains(nodeType)) {
+            return true;
+        }
+
+        // check effective node type
+        try {
+            NodeTypeRegistry registry = handler.getContext().getNodeTypeRegistry();
+            EffectiveNodeType type = registry.getEffectiveNodeType(primary, mixins);
+            return type.includesNodeType(nodeType);
+        } catch (NodeTypeConflictException e) {
+            log.warn("Failed to build effective node type for node {}", nodeState.getId());
+        } catch (NoSuchNodeTypeException e) {
+            log.warn("Failed to build effective node type for node {}", nodeState.getId());
         }
         return false;
     }
